package com.jcx.soft.controller;

package ..deTemp.1742528978041;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.jcx.soft.support.beans.ResultObject;
import com.jcx.soft.support.utils.ConfigHolder;
import com.jcx.soft.support.utils.fileCatalogueStructureTool;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.imageio.ImageIO;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

@Controller
@RequestMapping({"/info/file"})
public class FileController {
  private static final String[] IMAGES = new String[] { ".jpg", ".gif", ".png" };
  
  private static final String[] DOCS = new String[] { ".pdf", ".doc", ".docx", ".xls", ".xlsx", ".ppt", ".pptx", ".rar", ".zip" };
  
  @Autowired
  ConfigHolder configHolder;
  
  @RequestMapping({"/upload.action"})
  public void upload(Model model, HttpServletRequest request, HttpServletResponse response, @RequestParam("file") MultipartFile[] commoPicArr) {
    File f = null;
    String upLoadPath = this.configHolder.getConfig("upimg.path");
    String filePath = "/" + upLoadPath;
    Map<String, Object> map = new HashMap<>();
    ObjectMapper mapper = new ObjectMapper();
    if (commoPicArr[0].getOriginalFilename().equals("")) {
      try {
        map.put("state", "is null");
        String json = mapper.writeValueAsString(map);
        response.getWriter().print(json);
      } catch (JsonProcessingException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      } finally {}
      return;
    } 
    List<String> fileOldNameList = new ArrayList<>();
    List<String> I = Arrays.asList(IMAGES);
    List<String> D = Arrays.asList(DOCS);
    List<String> imgList = new ArrayList<>();
    List<String> docList = new ArrayList<>();
    List<String> docOldList = new ArrayList<>();
    List<String> width = new ArrayList<>();
    try {
      request.setCharacterEncoding("utf-8");
      response.setCharacterEncoding("utf-8");
      String path = request.getSession().getServletContext().getRealPath(filePath);
      if (commoPicArr[0].getOriginalFilename().equals(""))
        return; 
      if (path == null)
        return; 
      for (int i = 0; i < commoPicArr.length; i++) {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
        String nameall = commoPicArr[i].getOriginalFilename();
        fileOldNameList.add(nameall);
        String name = String.valueOf(df.format(new Date())) + i + nameall.substring(nameall.indexOf("."));
        System.out.println(path);
        File dir = new File(path, name);
        if (!dir.exists())
          dir.mkdirs(); 
        commoPicArr[i].transferTo(dir);
        if (I.contains(nameall.substring(nameall.indexOf(".")))) {
          BufferedImage img = ImageIO.read(dir);
          width.add(String.valueOf(img.getWidth()));
          imgList.add(name);
        } else {
          docList.add(name);
          docOldList.add(nameall);
        } 
      } 
      map.put("width", width);
      map.put("imgList", imgList);
      map.put("docList", docList);
      map.put("docOldList", docOldList);
      map.put("url", String.valueOf(request.getContextPath()) + filePath + "/");
      String json = mapper.writeValueAsString(map);
      response.getWriter().print(json);
    } catch (UnsupportedEncodingException e) {
      e.printStackTrace();
    } catch (IllegalStateException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  @RequestMapping({"/imgupload.action"})
  public void imgUpload(@RequestParam("upload") MultipartFile files, HttpServletResponse response, HttpServletRequest request) {
    try {
      request.setCharacterEncoding("utf-8");
      response.setCharacterEncoding("utf-8");
      PrintWriter out = response.getWriter();
      String callback = request.getParameter("CKEditorFuncNum");
      String upLoadPath = this.configHolder.getConfig("upimg.path");
      String filePath = upLoadPath;
      String path = request.getSession().getServletContext().getRealPath(filePath);
      if (path == null) {
        System.out.println("无法访问存储目录");
        return;
      } 
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss-SSSS");
      String nameall = files.getOriginalFilename();
      String name = String.valueOf(df.format(new Date())) + nameall.substring(nameall.indexOf("."));
      File dir = new File(path, name);
      if (!dir.exists())
        dir.mkdirs(); 
      files.transferTo(dir);
      String returnStr = "{\"uploaded\" : 1, \"fileName\" : \"" + name + "\"" + ", \"url\":" + "\"" + request.getContextPath() + "/" + filePath + "/" + name + "\"" + "}";
      out.println(returnStr);
    } catch (UnsupportedEncodingException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  @RequestMapping({"fileUploadIndex.action"})
  public String fileUploadIndexView(Model model, HttpServletRequest req) {
    String upLoadRootPath = String.valueOf(this.configHolder.getConfig("saveinfo.path")) + "lnzkbfiles";
    fileCatalogueStructureTool.getCatalogueStructure(upLoadRootPath, "#", req, Boolean.valueOf(false));
    List<Map> list = new ArrayList<>();
    list.addAll(fileCatalogueStructureTool.getFileCatalogueStructure());
    fileCatalogueStructureTool.distoryList();
    ObjectMapper mapper = new ObjectMapper();
    int l = list.size();
    try {
      String json = mapper.writeValueAsString(list);
      model.addAttribute("tree", json);
    } catch (JsonProcessingException e) {
      e.printStackTrace();
    } 
    return "fileUpload/index";
  }
  
  @RequestMapping({"newFolder.action"})
  @ResponseBody
  public ResultObject newFolder(HttpSession sess, HttpServletRequest request) {
    String name = request.getParameter("name");
    String path = request.getParameter("path");
    int index = name.indexOf("/");
    if (index == -1)
      name = "/" + name; 
    path = String.valueOf(this.configHolder.getConfig("saveinfo.path")) + path + name;
    File file = new File(path);
    if (!file.exists())
      file.mkdir(); 
    return new ResultObject(ResultObject.OK, "");
  }
  
  @RequestMapping({"fileUpload.action"})
  @ResponseBody
  public void fileUpload(HttpServletRequest request, HttpServletResponse response, @RequestParam("file") MultipartFile[] files) throws IOException {
    Map<String, Object> map = new HashMap<>();
    ObjectMapper mapper = new ObjectMapper();
    try {
      String path = request.getParameter("path");
      path = String.valueOf(this.configHolder.getConfig("saveinfo.path")) + path;
      request.setCharacterEncoding("utf-8");
      response.setCharacterEncoding("utf-8");
      Map<String, String> fileNMap = new HashMap<>();
      fileNMap.put(".a1", ".html");
      fileNMap.put(".a2", ".htm");
      byte b;
      int i;
      MultipartFile[] arrayOfMultipartFile;
      for (i = (arrayOfMultipartFile = files).length, b = 0; b < i; ) {
        MultipartFile file = arrayOfMultipartFile[b];
        String name = file.getOriginalFilename();
        if (name == null || name.equals(null) || name.equals("")) {
          map.put("statu", "-1");
          String str = mapper.writeValueAsString(map);
          response.getWriter().print(str);
          return;
        } 
        Set<String> iterator = fileNMap.keySet();
        for (String key : iterator) {
          int index = name.lastIndexOf(key);
          if (index != -1) {
            String p_n = name.substring(0, index);
            name = String.valueOf(p_n) + (String)fileNMap.get(key);
          } 
        } 
        File dir = new File(path, name);
        if (!dir.exists())
          dir.mkdir(); 
        file.transferTo(dir);
        b++;
      } 
      map.put("statu", "1");
      String json = mapper.writeValueAsString(map);
      response.getWriter().print(json);
    } catch (Exception e) {
      map.put("statu", "0");
      String json = mapper.writeValueAsString(map);
      response.getWriter().print(json);
    } 
  }
  
  @RequestMapping({"showDir.action"})
  @ResponseBody
  public void showDir(@RequestParam(value = "upLoadRootPath", defaultValue = "") String upLoadRootPath, @RequestParam(value = "parentid", defaultValue = "#") String parentid, HttpServletRequest req, HttpServletResponse response, String code) {
    try {
      req.setCharacterEncoding("utf-8");
      response.setCharacterEncoding("utf-8");
      response.setContentType("application/json; charset=utf-8");
      String str = code.equals("0") ? "lnzkbfiles/" : "";
      upLoadRootPath = String.valueOf(this.configHolder.getConfig("saveinfomake.path")) + str + upLoadRootPath;
      File file = new File(upLoadRootPath);
      if (!file.isDirectory())
        return; 
      fileCatalogueStructureTool.getCatalogueStructure(upLoadRootPath, parentid, req, Boolean.valueOf(false));
      List<Map> list = new ArrayList<>();
      list.addAll(fileCatalogueStructureTool.getFileCatalogueStructure());
      int l = list.size();
      fileCatalogueStructureTool.distoryList();
      ObjectMapper mapper = new ObjectMapper();
      String json = mapper.writeValueAsString(list);
      response.getWriter().print(json);
    } catch (JsonProcessingException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  @RequestMapping({"fileShow.action"})
  public String fileShow(Model model, HttpServletRequest req, String code) {
    Boolean flag = Boolean.valueOf(code.equals("0"));
    String upLoadRootPath = this.configHolder.getConfig("saveinfomake.path");
    upLoadRootPath = flag.booleanValue() ? (String.valueOf(upLoadRootPath) + "lnzkbfiles/") : upLoadRootPath;
    fileCatalogueStructureTool.getCatalogueStructure(upLoadRootPath, "#", req, Boolean.valueOf(false));
    List<Map> list = new ArrayList<>();
    list.addAll(fileCatalogueStructureTool.getFileCatalogueStructure());
    fileCatalogueStructureTool.distoryList();
    ObjectMapper mapper = new ObjectMapper();
    int l = list.size();
    try {
      String json = mapper.writeValueAsString(list);
      model.addAttribute("tree", json);
    } catch (JsonProcessingException e) {
      e.printStackTrace();
    } 
    if (flag.booleanValue())
      return "fileUpload/index"; 
    return "fileUpload/index1";
  }
}
